/*****************************************************************************/
/*	Copyright Sebastian Meuren 2003, 2008 
	
	This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>. */
/*****************************************************************************/
#ifndef __CS8900
#define	__CS8900
#include	"ethernet.h"
/*****************************************************************************/
/*	IO-Ports of the cs8900	*/
#define	CS_DATAPORT0		0
#define CS_DATAPORT1		2
#define CS_TXCMD			4
#define CS_TXLENGTH			6
#define CS_ISQ				8
#define CS_PPP				0xA
#define CS_PPDATA0			0xC
#define CS_PPDATA1			0xD
/*****************************************************************************/
#define	CS_REGID_MASK					0x001F		//Valid id-bits
/*	Event-Register */
#define	CS_REG_RECEIVEEVENT				0x0124
#define	CS_REGID_RECEIVEEVENT			0x4
#define	CS_REG_TRANSMITEVENT			0x0128
#define	CS_REGID_TRANSMITEVENT			0x8
#define	CS_REG_BUFFEREVENT				0x012C
#define	CS_REGID_BUFFEREVENT			0xC
#define	CS_REG_RECEIVEMISSEVENT			0x0130
#define	CS_REGID_RECEIVEMISSEVENT		0x10
#define	CS_REG_TRANSMITCOLLISIONEVENT	0x0132
#define	CS_REGID_TRANSMITCOLLISIONEVENT	0x12
/*	Control-Register */
#define CS_REG_SELFCONTROL				0x0114
#define CS_REG_LINECONTROL				0x0112
#define CS_REG_RECEIVERCONFIGURATION	0x0102
#define CS_REG_RECEIVERCONTROL			0x0104
#define CS_REG_BUSCONTROL				0x0116
#define CS_REG_TRANSMITCONFIGURATION	0x0106
#define	CS_REG_BUFFERCONFIGURATION		0x010A
#define	CS_REGID_BUFFERCONFIGURATION	0xB
#define	CS_REG_TESTCONTROL				0x0118
/*	Status-Register */
#define	CS_REG_TRANSMITCOMMANDSTATUS	0x0108
#define	CS_REG_TRANSMITCOMMAND			0x0144
#define	CS_REG_TRANSMITFRAMELENGTH		0x0146
#define	CS_REG_SELFSTATUS				0x0136
#define	CS_REG_BUSSTATUS				0x0138
/*	MAC-Addresse: from this address up */
#define	CS_REG_INDIVIDUALADDRESS		0x0158
/*****************************************************************************/

//ATmega64 MWS Declaration
#define	CS_DATALOW_PORT		PORTE
#define	CS_DATALOW_DDR		DDRE
#define	CS_DATALOW_PIN		PINE
#define	CS_DATAHIGH_PORT	PORTC
#define	CS_DATAHIGH_DDR		DDRC
#define	CS_DATAHIGH_PIN		PINC	
#define	CS_ADD_PORT			PORTG
#define	CS_ADD_DDR			DDRG
#define	CS_ADD_PIN			PING
#define	CS_ADD_MASK			0x0F

#define	CS_IRQ_ENABLE		EIMSK  |= _BV(INT2); 
#define	CS_IRQ_DISABLE		EIMSK  &= ~_BV(INT2); 


#define	CS_IOR_INIT		DDRB  |= _BV(4); 
#define	CS_IOR_HI 		PORTB |= _BV(4);
#define	CS_IOR_LO 		PORTB &= ~_BV(4);

#define	CS_IOW_INIT		DDRB  |= _BV(5);
#define	CS_IOW_HI 		PORTB |= _BV(5);
#define	CS_IOW_LO 		PORTB &= ~_BV(5);

#define	CS_RESET_INIT	DDRB  |= _BV(6);
#define	CS_RESET_HI 	PORTB |= _BV(6);
#define	CS_RESET_LO 	PORTB &= ~_BV(6);

#define	CS_SBHE_INIT	DDRF  |= _BV(3);
#define	CS_SBHE_HI 	 	PORTF |= _BV(3);
#define	CS_SBHE_LO 		PORTF &= ~_BV(3);

/*****************************************************************************/
/*	API	*/
/*****************************************************************************/
/*	CS8900 - Interface */
void	cs_regwrite(uint uiAddress,uint uiData);
uint	cs_regread(uint uiAddress);
void	cs_write_16bit(char ucAddress,uint uiData);
uint	cs_read_16bit(char ucAddress);
void	cs_setmac(MACADDRESS* psMac);
void	cs_senddata(void* pFrame,uint uiLength);
void	cs_readdata(void* pBuffer,uint uiLength);
void	cs_waittxready(uint uiLength);
void	cs_waittxdone(void);
void	cs_sendframe(void* pFrame,uint uiLength);
void	cs_sendword(uint uiValue,uint uiCnt);
void	cs_init(void);
/*****************************************************************************/
#endif
