/*****************************************************************************/
/*	Copyright Sebastian Meuren 2003, 2008 
	
	This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>. */
/*****************************************************************************/
#ifndef ENC28J60__
#define ENC28J60__
/*	CS-Line ENC28J60: High Output */
#define ENC_CONFIGURE_CS		DDRB 	|= _BV(0); 	PORTB 	|= _BV(0);
/*	INT: Input, nothing has to be done */
#define	ENC_CONFIGURE_INT	
/* Changing Pins */
#define	ENC_INT_STATUS		(PIND & _BV(3))
#define	ENC_SELECT_CS		PORTB |= _BV(0);
#define	ENC_DESELECT_CS		PORTB &= ~_BV(0);
/* Interrupt */
#define	CS_IRQ_ENABLE		EIMSK  |= _BV(INT1); 
#define	CS_IRQ_DISABLE		EIMSK  &= ~_BV(INT1); 

/*	PHY Register */
#define	ENC_PHCON1		0x00
#define	ENC_PHSTAT1		0x01
#define	ENC_PHCON2		0x10
#define	ENC_PHSTAT2		0x11
/*	Control-Register 
 * Control registers for the ENC28J60 are genericall
grouped as ETH, MAC and MII registers. Registe
names starting with “E” belong to the ETH group
Similarly, registers names starting with “MA” belong t
the MAC group and registers prefixed with “MI” belon
to the MII group.
If the address specifies one of the MAC or MII registers,
a dummy byte will first be shifted out on the SO pin.
After the dummy byte, the data will be shifted out MSb
first on the SO pin.
*/
#define	ENC_ERDPTL		(0x00 | 0x00 | 0x00)
#define	ENC_ERDPTH		(0x01 | 0x00 | 0x00)
#define	ENC_EWRPTL		(0x02 | 0x00 | 0x00)
#define	ENC_EWRPTH		(0x03 | 0x00 | 0x00)
#define	ENC_ETXSTL		(0x04 | 0x00 | 0x00)
#define	ENC_ETXSTH		(0x05 | 0x00 | 0x00)
#define	ENC_ETXNDL		(0x06 | 0x00 | 0x00)
#define	ENC_ETXNDH		(0x07 | 0x00 | 0x00)
#define	ENC_ERXSTL		(0x08 | 0x00 | 0x00)
#define	ENC_ERXSTH		(0x09 | 0x00 | 0x00)
#define	ENC_ERXNDL		(0x0A | 0x00 | 0x00)
#define	ENC_ERXNDH		(0x0B | 0x00 | 0x00)
#define	ENC_ERXRDPTL	(0x0C | 0x00 | 0x00)
#define	ENC_ERXRDPTH	(0x0D | 0x00 | 0x00)
#define	ENC_ERXWRPTL	(0x0E | 0x00 | 0x00)
#define	ENC_ERXWRPTH	(0x0F | 0x00 | 0x00)

#define	ENC_EDMASTL		(0x10 | 0x00 | 0x00)
#define	ENC_EDMASTH		(0x11 | 0x00 | 0x00)
#define	ENC_EDMANDL		(0x12 | 0x00 | 0x00)
#define	ENC_EDMANDH		(0x13 | 0x00 | 0x00)

#define	ENC_EDMACSL		(0x16 | 0x00 | 0x00)
#define	ENC_EDMACSH		(0x17 | 0x00 | 0x00)

#define	ENC_EBSTSD		(0x06 | 0x60 | 0x00)	//(Bank3, Address 0x06, no Dummybyte)
#define	ENC_EBSTCON		(0x07 | 0x60 | 0x00)	//(Bank3, Address 0x07, no Dummybyte)
#define	ENC_EBSTCSL		(0x08 | 0x60 | 0x00)	//(Bank3, Address 0x08, no Dummybyte)
#define	ENC_EBSTCSH		(0x09 | 0x60 | 0x00)	//(Bank3, Address 0x09, no Dummybyte)

#define	ENC_MAADR1		(0x04 | 0x60 | 0x80)	//(Bank3, Address 0x04,Dummybyte)
#define	ENC_MAADR2		(0x05 | 0x60 | 0x80)	//(Bank3, Address 0x05,Dummybyte)
#define	ENC_MAADR3		(0x02 | 0x60 | 0x80)	//(Bank3, Address 0x02,Dummybyte)
#define	ENC_MAADR4		(0x03 | 0x60 | 0x80)	//(Bank3, Address 0x03,Dummybyte)
#define	ENC_MAADR5		(0x00 | 0x60 | 0x80)	//(Bank3, Address 0x00,Dummybyte)
#define	ENC_MAADR6		(0x01 | 0x60 | 0x80)	//(Bank3, Address 0x01,Dummybyte)
#define	ENC_MIREGADR	(0x14 | 0x40 | 0x80)	//(Bank2, Address 0x14,Dummybyte)
#define	ENC_MIWRL		(0x16 | 0x40 | 0x80)	//(Bank2, Address 0x16,Dummybyte)
#define	ENC_MIWRH		(0x17 | 0x40 | 0x80)	//(Bank2, Address 0x17,Dummybyte)
#define	ENC_MIRDL		(0x18 | 0x40 | 0x80)	//(Bank2, Address 0x18,Dummybyte)
#define	ENC_MIRDH		(0x19 | 0x40 | 0x80)	//(Bank2, Address 0x19,Dummybyte)
#define	ENC_MISTAT		(0x0A | 0x60 | 0x80)	//(Bank3, Address 0x0A,Dummybyte)
#define	ENC_MICMD		(0x12 | 0x40 | 0x80)	//(Bank2, Address 0x12,Dummybyte)
#define	ENC_ESTAT		0x1D			//(Bank0, Address 0x1D,no Dummybyte)
#define	ENC_ECON1		0x1F			//(Bank0, Address 0x1F,no Dummybyte)
#define	ENC_ECON2		0x1E			//(Bank0, Address 0x1E,no Dummybyte)
#define	ENC_EIE			0x1B			//(Bank0, Address 0x1B,no Dummybyte)
#define	ENC_EREVID		(0x12 |0x60 | 0x00)		//(Bank3, Address 0x12,no Dummybyte)
#define	ENC_EIR			0x1C			//(Bank0, Address 0x1C,no Dummybyte)
#define	ENC_EPKTCNT		(0x19 | 0x20 | 0x00)	//(Bank1, Address 0x19, no Dummybyte)
#define	ENC_ERXFCON		(0x18 | 0x20 | 0x00)	//(Bank1, Address 0x18, no Dummybyte)
#define	ENC_MACON1		(0x00 | 0x40 | 0x80)	//(Bank2, Address 0x00,Dummybyte)
#define	ENC_MACON3		(0x02 | 0x40 | 0x80)	//(Bank2, Address 0x02,Dummybyte)
#define	ENC_MACON4		(0x03 | 0x40 | 0x80)	//(Bank2, Address 0x03,Dummybyte)
#define	ENC_MAMXFLL		(0x0A | 0x40 | 0x80)	//(Bank2, Address 0x0A,Dummybyte)
#define	ENC_MAMXFLH		(0x0B | 0x40 | 0x80)	//(Bank2, Address 0x0B,Dummybyte)
#define	ENC_MABBIPG		(0x04 | 0x40 | 0x80)	//(Bank2, Address 0x04,Dummybyte)
#define	ENC_MAIPGL		(0x06 | 0x40 | 0x80)	//(Bank2, Address 0x06,Dummybyte)
#define	ENC_MAIPGH		(0x07 | 0x40 | 0x80)	//(Bank2, Address 0x07,Dummybyte)
/*	User Settings: Buffer */
/* The entire buffer is 8 Kbytes.
 * RECEIVE BUFFER: ERXSTH:ERXSTL and ERXNDH:ERXNDL define the buffer’s size and
 *  location ERXST and ERXND are both included in the FIFO */

/* The ERXWRPTH:ERXWRPTL registers define a location within the FIFO where the hardware will write
 * bytes that it receives. The pointer is read-only and is automatically updated by the hardware whenever
 * a new packet is successfully received. The pointer is 
 * useful for determining how much free space is available within the FIFO. */
/* The ERXRDPT registers define a location within the FIFO where the receive hardware is forbidden
 * to write to. In normal operation, the receive hardware will write
data up to, but not including, the memory pointed to by
ERXRDPT. If the FIFO fills up with data and new data
continues to arrive, the hardware will not overwrite the
previously received data. Instead, the new data will be
thrown away and the old data will be preserved. In
order to continuously receive new data, the host con-
troller must periodically advance this pointer whenever
it finishes processing some, or all, of the old received
data. */
/*	See ERRATA: The receiver Buffer should start at 0x0000! */
#define	ENC_RXST		0x0000
#define	ENC_RXND		0x0FFF
#define	ENC_TXST		(0x1100)
/*	Maximum framelength allowed to transmitt/receive */
#define	ENC_MAXFRAMELENGTH	1518
void	enc_reset(void);
void	enc_spiconfig(void);
void	enc_writecontrolregister_lowlevel(u8 u8Address,u8 u8Data);
u8		enc_readcontrolregister_lowlevel(u8 u8Address);
void	enc_bitfieldclear_lowlevel(u8 u8Address,u8 u8Data);
void	enc_bitfieldset_lowlevel(u8 u8Address,u8 u8Data);
u8		enc_getbank(void);
/* API */
void	enc_writecontrolregister(u8 u8Address,u8 u8Data);
u8		enc_readcontrolregister(u8 u8Address);
void	enc_bitfieldclear(u8 u8Address,u8 u8Data);
void	enc_bitfieldset(u8 u8Address,u8 u8Data);
u16		enc_readphyregister(u8 u8Address);
void	enc_writephyregister(u8 u8Address,u16 u16Data);
#endif /*ENC28J60__*/
