/*****************************************************************************/
/*	Copyright Sebastian Meuren 2003, 2008 
	
	This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>. */
/*****************************************************************************/
/*	ICMP */
/*****************************************************************************/
#ifndef __ICMP
#define	__ICMP
#include "global.h"
#include "system.h"
#include "network.h"
#include "ethernet.h"
#include "ip-udp.h"
#include "arp.h"
/*---------------------------------------------------------------------------*/
/* constants */
/*---------------------------------------------------------------------------*/
#define	ICMP_ECHOREADY				0
#define	ICMP_ECHOGETMAC				1
#define	ICMP_ECHOWAITARPRESPONSE	2
#define	ICMP_ECHOSEND				3
/*---------------------------------------------------------------------------*/
/* structs */
/*---------------------------------------------------------------------------*/
typedef struct _ICMPHEADER ICMPHEADER;
struct _ICMPHEADER{
uchar	ucType;
uchar	ucCode;
uchar	ucChecksumHigh;
uchar	ucChecksumLow;
};
/*---------------------------------------------------------------------------*/
/* API */
/*---------------------------------------------------------------------------*/
void	icmp_init(void);
void	icmp_transmit(void);
void	icmp_arpcallback(ARPQUERYNODE* pNode,char cCode);
void	icmp_receivepacket(void);
/*---------------------------------------------------------------------------*/
/* globals */
/*---------------------------------------------------------------------------*/
char*			gpICMPEchoBuffer;
uint			guiICMPEchoBufferLen;
uint			guiICMPIPIdentification;
char			gcICMPEchoStatus;
ARPQUERYNODE 	gsICMPArpQuery;
/*****************************************************************************/
#endif
