/*****************************************************************************/
/*	Copyright Sebastian Meuren 2003, 2008 
	
	This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>. */
/*****************************************************************************/
/* IP / UDP */
/*****************************************************************************/
#ifndef	__IPUDP
#define	__IPUDP
#include	"global.h"
#include	"inttypes.h"
#include	"system.h"
#include	"network.h"
/*****************************************************************************/
/*---------------------------------------------------------------------------*/
/* structs */
/*---------------------------------------------------------------------------*/
typedef	struct	_IPADDRESS IPADDRESS;
typedef	struct	_IPHEADER IPHEADER;
typedef	struct	_UDPPSEUDOHEADER UDPPSEUDOHEADER;
typedef struct	_UDPHEADER UDPHEADER;
struct _IPADDRESS{
uchar	ucAddress[4];
};
struct	_IPHEADER{
uchar		ucVersHlen;
uchar		ucServiceType;
uchar		ucTotalLengthHigh;
uchar		ucTotalLengthLow;
uchar		ucIdentificationHigh;
uchar		ucIdentificationLow;
uchar		ucFlagsFragmentOffsetHigh;
uchar		ucFlagsFragmentOffsetLow;
uchar		ucTTL;
uchar		ucProtocol;
uchar		ucHeaderChecksumHigh;
uchar		ucHeaderChecksumLow;
IPADDRESS	sSourceIpAddress;
IPADDRESS	sDestinationIpAddress;
};
struct	_UDPPSEUDOHEADER{
IPADDRESS	sSourceIpAddress;
IPADDRESS	sDestinationIpAddress;
uchar		ucZero;
uchar		ucProto;
uchar		ucUDPLengthHigh;
uchar		ucUDPLengthLow;
};
struct	_UDPHEADER{
uchar	ucUDPSourcePortHigh;
uchar	ucUDPSourcePortLow;
uchar	ucUDPDestinationPortHigh;
uchar	ucUDPDestinationPortLow;
uchar	ucUDPMessageLengthHigh;
uchar	ucUDPMessageLengthLow;
uchar	ucUDPChecksumHigh;
uchar	ucUDPChecksumLow;
};
/*---------------------------------------------------------------------------*/
/* constants */
/*---------------------------------------------------------------------------*/
#define	IPTTL	125
/*---------------------------------------------------------------------------*/
/* macros */
/*---------------------------------------------------------------------------*/
#define	SETIPADDRESS(Ip,cOct3,cOct2,cOct1,cOct0)\
		Ip.ucAddress[0]	=	cOct3;\
		Ip.ucAddress[1]	=	cOct2;\
		Ip.ucAddress[2]	=	cOct1;\
		Ip.ucAddress[3]	=	cOct0;
#define	IPCOMPARE(ip1,ip2) ((ip1.ucAddress[0] == ip2.ucAddress[0]) &&\
	(ip1.ucAddress[1] == ip2.ucAddress[1]) &&\
	(ip1.ucAddress[2] == ip2.ucAddress[2]) &&\
	(ip1.ucAddress[3] == ip2.ucAddress[3]))
/*---------------------------------------------------------------------------*/
/* api */
/*---------------------------------------------------------------------------*/
void	ip_init(void);
uint	ip_datalength(IPHEADER* spIPHeader);
uint	ip_checksum16bit(uint uiChecksum, uint uiValue);
uint	ip_constchecksum(uint uiChecksum, uint uiValue, uint uiLength);
uint	ip_checksum(uint uiChecksum, void* pBuffer, uint uiLength);
uint	ip_verifychecksum(IPHEADER* pHeader);
uint	udp_pseudoheaderchecksum(IPADDRESS* spSourceIP,IPADDRESS* spDestIP,uint uiLength);
void*	ip_writeheader(void* pHeader,char cProtocol,uint uiDataLength,IPADDRESS* spSourceIp,IPADDRESS* spDestinationIp,uint uiIdentification);
void*	udp_writeheader(void* pHeader,uint uiSourcePort,uint uiDestinationPort,uint uiLength);
void	udp_writechecksum(UDPHEADER* pUDPHeader, uint uiChecksum);
void	udp_receivepacket(void);
void	ip_receivepackage(void);
/*---------------------------------------------------------------------------*/
IPADDRESS	zeroip;
IPADDRESS	broadip;
IPADDRESS	myip;
IPADDRESS	dhcpip;
IPADDRESS	routerip;
IPADDRESS	nameserverip;
IPADDRESS	dhcpserverip;
IPADDRESS	subnetmask;
/*****************************************************************************/
#endif
