/*****************************************************************************/
/*	Copyright Sebastian Meuren 2003, 2008 
	
	This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>. */
/*****************************************************************************/
/* TCP */
/*****************************************************************************/
#include "tcp.h"
			/*	DANGER: We have to ensure that if in the Established-
				State we get an SYN&ACK, we repeat the Acknowledge!!! */
/*	Have to setup a SYN-Send Timeout!!! */
/*	DANGER: Open: Fin-States, etc. not considered */
u8	u8test[sizeof(ETHERNETHEADER)];
/*****************************************************************************/
/* TCP-RECEIVE */
/*****************************************************************************/
void	tcp_receivepackage(void){
/*	The ip-layer has proceded a package that is addressed to TCP */
TCPLISTEN*		spListenNext;
ETHERNETHEADER*	spEthernetHeader	= (void*)(((uchar*)&gu8NetworkBuffer));
IPHEADER*		spIPHeader			= (void*)(((uchar*)&gu8NetworkBuffer)+sizeof(ETHERNETHEADER));
TCPHEADER*		spTCPHeader			= (void*)(((uchar*)&gu8NetworkBuffer)+sizeof(ETHERNETHEADER)+sizeof(IPHEADER));

u16			u16tmp;
u16			u16ReadLength;
u16			u16TcpHeaderLength;
u16			u16IPPacketLength;
u16			u16TcpDataLength;
u16			u16TcpOptionLength;
u16			u16TcpWindowSize;
TCPTCB*		spTCB;
TCPTCB**	sppTCBNext;
u8			u8Flags;
u8			u8ValidAck;
u32			u32AckNumber;
u32			u32LastAck;
u32			u32LastSend;
u16			u16AckDataCount;
u16			u16Tmp;

u8*			u8pRead;
u8*			u8pWrite;
u8*			u8pStart;
u8*			u8pStop;
u16			u16Free;
u16			u16Written;
u16			u16WriteLength;
/*****************************************************************************/
/* Process the TCP-Header */
/*****************************************************************************/
/*	Read the tcp-header */
	u16ReadLength	=	ethernet_readframe(spTCPHeader,sizeof(TCPHEADER));
	if(u16ReadLength	<	sizeof(TCPHEADER)){
		/*	The received package doesn't contain a full header */
		return;
	}

	

	/*	Make the CS-Pin high */
//	ENC_SELECT_CS
	/*	Release the SPI-Bus */
//	SignalEvent(&gsSpiLockEvent);

//	ethernet_writeheader(u8test,&mymac,&debugmac,0x0888);
//	ethernet_waittxready(2*sizeof(ETHERNETHEADER)+sizeof(TCPHEADER)+sizeof(IPHEADER));
	/*	Send the Header over the ether */
//	ethernet_senddata(u8test,sizeof(ETHERNETHEADER));
//	ethernet_senddata(spEthernetHeader,sizeof(ETHERNETHEADER)+sizeof(TCPHEADER)+sizeof(IPHEADER));
	//	ethernet_senddata(&spTCB->u32LocalReceived,4);
	/*	Wait until the job is done */
//	ethernet_waittxdone();	

	/*	Wait until the SPI-Bus is ready */
//	WaitEvent(&gsSpiLockEvent);
	/*	Setup the SPI-Speed */
//	enc_spiconfig();
	/*	Make the CS-Pin low */		
//	ENC_DESELECT_CS
//	asm volatile("nop"::);
//	asm volatile("nop"::);
//	asm volatile("nop"::);
//	asm volatile("nop"::);
//	asm volatile("nop"::);
	/*	Write Instruction : Consists of a 3-Bit Opcode (001: Read buffer memory) and 
	 * 	the 5-Bit code 11010 */
//	spi_rw(0x3A);
	
	
	
	
/*	We got a whole header: ignore options if they are present */
/*	Danger! The Data-Offset occupies only the upper 4 bit */
	u16TcpHeaderLength	= (spTCPHeader->u8DataOffset & 0xF0) >> 2;
	u16IPPacketLength	= ip_datalength(spIPHeader);
	u16TcpDataLength	= u16IPPacketLength - u16TcpHeaderLength;
	u16TcpOptionLength	= (u16TcpHeaderLength- sizeof(TCPHEADER))/2;
/*	DANGER: The packet-length can't be retrieved by finding out
	how long the packet is, because the Ethernet-Hardware may have
	fit the packet to a specific size */
/*	Ignore the options: through them away */
	u16tmp	= u16TcpOptionLength*2;
	if(ethernet_dropframecontents(u16tmp) != u16tmp){
		/*	If we were not able to through away the options: packet corrupted */
		return;
	}
/*	Now we can read the TCP-data from the packet.
	Because the Ethernet-Frame may be longer, we have to take care
	of this */
	if(ethernet_truncateframe(u16TcpDataLength) != u16TcpDataLength){
		/*	If we did not have enough data in the packet: packet corrupted */
		return;
	}
/*****************************************************************************/
/* Search the corresponding TCB */
/*****************************************************************************/
/*	Search in the Queue for a TCB that fit's the incomming parameters */
	spTCB	= gspTcpQueue;	//Start at the beginning
	while(spTCB != 0){
		/*	Test, if the Ports fit:
			The Packet's Destination-Port has to match the TCBs Source-Port,
			The Packet's Source-Port has to match with the TCBs Destination Port
			The Packet's IP has to mach with the TCBs Destination IP */
			if(TCPPORTCOMPARE(spTCB->sLocalTcpPort,spTCPHeader->sDestPort) \
				&& TCPPORTCOMPARE(spTCB->sRemoteTcpPort,spTCPHeader->sSourcePort) \
				&& IPCOMPARE(spTCB->sRemoteIp,spIPHeader->sSourceIpAddress)){
				/*	The packet matches the TCB */
				break;
			}
		/*	Get next node */
		spTCB	= spTCB->spNext;
	}
/*	We may have a TCB to which the received packet belongs */
	u8Flags	= spTCPHeader->u8Flags;
/*****************************************************************************/
/* Process a new connection if the TCB wasn`t found */
/*****************************************************************************/
if(spTCB == 0){
	/*	We couldn't find the TCB. Maybe this packet tries to establish a new connection
		*/
	if(((spTCPHeader->u8Flags & TCP_SYN) != 0) && ((spTCPHeader->u8Flags & TCP_ACK) == 0)){
		/*	We received a SYN without ACK: A remote Client-process tries to connect
		- search for a listening server-process on this machine */
		spListenNext	= gspTcpListenList;	//Start at the beginning of the list
	/*	Walk through the list and search for the port */
		while(spListenNext != 0){
			/*	compare the Local Port */
			if(TCPPORTCOMPARE(spListenNext->sTcpPort,spTCPHeader->sDestPort)){
				/*	We have a match */
				if(tcp_connectioncnt(&spListenNext->sTcpPort) >= spListenNext->u8MaxTCB){
					/* The maximum number of connections for this port is reached */
					return;
				}
				/*	The connection should be established. try to allocate
					space for the TCB */
				spTCB	= (TCPTCB*)_malloc(sizeof(TCPTCB));
				if(spTCB == 0){
				/*	No space for a TCB ! */
					return;
				}
				//------	INITIALIZE NEW TCB
				EnterCritical();
					/*	The timer-task has a higher priority, we have to
						keep at least the variables it access exclusive */
				spTCB->spNext					=	0;			//Last one in the chain
				spTCB->spTxNext					=	(TCPTCB*)1;	//Nothing to transmit so far
				spTCB->spListenNext				=	0;			//No more task on the listen-list!!!
				/*	We have to initialize the buffer */
				spTCB->u8pRxBufferRead		= spTCB->RxBuffer;;
				spTCB->u8pRxBufferWrite		= spTCB->RxBuffer;;
				spTCB->u16RxBufferFree		= TCP_RXBUFFERLENGTH;
				spTCB->u8pTxBufferRead		= spTCB->TxBuffer;
				spTCB->u8pTxBufferWrite		= spTCB->TxBuffer;
				spTCB->u16TxBufferFree		= TCP_TXBUFFERLENGTH;
				/*	We havent send anything yet, the offset is zero */
				spTCB->u16TxBufferOffset	=	0;
				/*	We have to initialize the TCP-Events */
				EVENTINIT(spTCB->sTCPTxEvent);
				EVENTINIT(spTCB->sTCPRxEvent);
				/*	Init the Timer */
				spTCB->s8TCPTxTimer					= 0;
				/*	We have no Retransmission so far */
				spTCB->u8TCPRetransmissionCounter	= 0;
				/*	We received a SYN-Packet. We are in the LISTEN-state: We should send an
					ACKnowledge as soon as possible */
				spTCB->u8TCPState				=	TCP_LISTEN;
				/*	No Flags set so far!! */
				spTCB->u8TCPFlags				=	0;
				/* 	Save the connection-data: IP,MAC,Port */
				spTCB->sRemoteMac				=	spEthernetHeader->sSource;
				spTCB->sRemoteIp				=	spIPHeader->sSourceIpAddress;
				spTCB->sRemoteTcpPort			=	spTCPHeader->sSourcePort;
				spTCB->sLocalTcpPort			=	spTCPHeader->sDestPort;
				/*	The byte-streams have to be setup */
				/*	This is our local Initial Sequence-number */
				spTCB->u32RemoteReceived		=	tcp_seqnumber(spTCPHeader) + 1;
				/*	Save the remote window size */
				spTCB->u16RemoteWindowSize		=	tcp_windowsize(spTCPHeader);
				/*	remote initial sequence number */
				spTCB->u32LocalReceived			=	tcp_seqnumber(spTCPHeader) + 1;

				/*	Add the TCB to the global TCB-Queue */
				tcp_queuetcb(spTCB);
				/*	Add the TCB to the send-queue: we have to send an SYN/ACK back */
				tcp_queuetxtcb(spTCB);
				/*	Ensure that we send an ACK back */
				gu8NetworkSend	= 1;
				LeaveCritical();
				/*	Append the TCB to the list */
				sppTCBNext	=	&spListenNext->spNextTCB;
				/*	Search the end */
				while(*sppTCBNext != 0){
					sppTCBNext	= &(*sppTCBNext)->spListenNext;
				}
				/*	Add it */
				*sppTCBNext	= spTCB;
				/*	Signal the Listen-Event: maybe a task is waiting
					for an incomming connection */
				SignalEvent(&spListenNext->sListenEvent);
				/*Done*/
				return;
			}//END PORT COMPARE: Ports match
			/*	Get the next node */
			spListenNext	= spListenNext->spNext;
		}//END Listen-Search Loop
	}
	/* This is not a valid start for an incomming connection:
		We received a Packet which doesnt belong to an established
		connection and without a SYN-Flag */
		return;
}
/*****************************************************************************/
/* Proccess the incomming Data: Get ACK-Numbers */
/*****************************************************************************/
	/*	Get the ack-number of the current frame */
	u32AckNumber		= tcp_acknumber(spTCPHeader);
	u32LastAck			= spTCB->u32RemoteReceived;
	u32LastSend			= u32LastAck + spTCB->u16TxBufferOffset;
/*****************************************************************************/
/* Proccess the incomming Data: TCP FinitStateMachine */
/*****************************************************************************/
/*	It's important that this is processed before the ACK-Code is executed
	because during the handshake in the TCP_SYNRECEIVED-State we
	increment the ulSendAcknowledged. This is important to do befor
	the ACK-Code works, because the ACK of our SYN (We acting as a
	server) uses the incremented version in it's acknowledge message.
	The ACK-Code should workout that the ACK is valid, so this is important */
switch(spTCB->u8TCPState){
/*----- TCP_OPEN --------------------------------------------------------*/
		case TCP_OPEN:
		/*	We still have to send our SYN, so nothing has to be done */
			break;
/*----- TCP_SYNSENT  --------------------------------------------------------*/
		case TCP_SYNSENT:
		/*	We have send a SYN. Now we wait for a SYN&ACK.*/
		if((spTCPHeader->u8Flags & (TCP_ACK | TCP_SYN)) == (TCP_ACK | TCP_SYN)){
		/*	Step 2 of the 3-Way Handshake! We have to send back an
			Acknowledge. */
		/*	Lets check, if the Remote end acknowledges our SYN */
			if(u32AckNumber == (u32LastSend+1)){
				/*	We have a valid Acknowledge of our SYN-Flag (it has
					to be acknowledged like any other Data-octet).*/
				/* We have a SYN of the remote-site. We have to get the remote
				Initial sequence-number and we have to acknowledge the
				remote SYN. Lets do that! */
				spTCB->u32LocalReceived		=	tcp_seqnumber(spTCPHeader)+1;
				/*	We have send a SYN too. This was acknowledged by the
					remote side. Thus increment the Sequencenumber */
				spTCB->u32RemoteReceived++;
				/*	Reset the retransmission-Counter */
				EnterCritical();
				spTCB->u8TCPRetransmissionCounter	= 0;
				LeaveCritical();
				/*	change state to SYNSENT1 */
				spTCB->u8TCPState	= TCP_SYNSENT1;
				/*	ensure that we send an acknowledgement */
				tcp_queuetxtcb(spTCB);
			}else{
				/*	The sequence-number is invalid! */
				break;
			}
		}
		break;
/*----- TCP_SYNSENT1 --------------------------------------------------------*/
		case TCP_SYNSENT1:
		/*	We received a SYN/ACK, now we have to send an ACK back. Nothing
		 * 	has to be processed so far */ 
				break;
/*----- TCP_ESTABLISHED -----------------------------------------------------*/
		case	TCP_ESTABLISHED:
		/*	Test if the other side sends a FIN:
		 * 	this is done after we processed the data */
		break;
/*----- TCP_SYNRECEIVED -----------------------------------------------------*/
	case	TCP_SYNRECEIVED:
	/*	We have received a syn and send back a SYN & ACK. Now we are
		waiting for the Ack of our SYN (STEP 3 of the handshake)*/
		if((spTCPHeader->u8Flags & TCP_ACK) != 0){
		/*	The Remote-End Acknowledges our SYN (-Ack). It has to use a
			Sequence-Number wich is incremented by one. We have
			to take care of that and increment the Sequence-Number as
			well by one!!! (a SYN is acknowledged like a data-byte */
			/* DANGER: We can increase only after we received the remote
				acknowledge!!! Otherwise we have problems in case of a
				retransmission */
			spTCB->u32RemoteReceived++;
			/*	change state now to established */
			spTCB->u8TCPState	= TCP_ESTABLISHED;
		}
		break;
/*----- TCP_FINWAIT0 --------------------------------------------------------*/
	case	TCP_FINWAIT0:
	/*	Like Established, but we should close the connection as soon
		as we have no more data. Maybe we have a FIN from the other
		side. */
		if((u8Flags & TCP_FIN) != 0){
			/*	We are in the TCP_FINWAIT0-state and now we received a
				FIN from the other side. The TCP_FINWAIT0 is like the ESTABLISHED
				state, except that our user wants to close. Form ESTABLISHED we
				go to CLOSEWAIT in case of a received FIN. Then we go to the
				CLOSEWAIT0-state if our user wants to close. Thus now we simply
				go imidiatly to the CLOSEWAIT0-state!!!*/
				spTCB->u8TCPState	= TCP_CLOSEWAIT0;
			/*	We have a FIN. We need to Acknowledge the FIN. Thus we simply
				increment our Sequence number and we will automaticly acknowledge
				the FIN!! 
				DANGER: The CLOSEWAIT0-State has to transmitt an acknowledge!!!
				(but it will do this!!) */
				spTCB->u32LocalReceived++;
				/*	Start the Acknowledge-Timer to acknowledge the FIN */
				EnterCritical();
				spTCB->s8TCPTxTimer		= TCP_ACKNOWLEDGETIMEOUT;
				LeaveCritical();
			/*	Save the information, that the remote end has closed the
				connection */
			spTCB->u8TCPFlags		|= 	TCPFLAG_RXEOF;
		}
		break;
/*----- TCP_FINWAIT1 --------------------------------------------------------*/
	case	TCP_FINWAIT1:
	/*	We have send a FIN-Message, but we continue to receive
		data */
		if((u8Flags & TCP_ACK) == 0){
			/*	No ACK -Flag!! */
			break;
		}
		/* We have an ACK-Flag. Check if we have an Acknowledge of our FIN */
		if((TCP_TXBUFFERLENGTH - spTCB->u16TxBufferFree - spTCB->u16TxBufferOffset) == 0){
			/*	We may have stuff in the buffer, but it has been
				transmitted (thus no (re)transmission is going on */
			/*	Check if we have an Acknowledge of our FIN */
			if(u32AckNumber == (u32LastSend+1)){
				/*	We have a valid Acknowledge of our FIN-Flag (it has
					to be acknowledged like any other Data-octet).
					Later in this routine the Acknowledged data will be
					processed. There we will find out, that the currently
					processed Packet will Acknowledge all remaining Data,
					thus after this step we will have an empty buffer.
					This is important, we mustnt retransmitt after we
					accept that the remote end has acknowledged our FIN
					(Because we will increase the sequence-number!!!) */
					/*	The Remote-Site send an Ack!!! Now we have to
						change the state */
					spTCB->u8TCPState	= TCP_FINWAIT2;
					/*	Our FIN is acknowledged. Thus we have to increment our
						sequence-number by one because a FIN counts like a data
						octet */
					/* DANGER: We can increase only after we received the remote
						acknowledge of our FIN!!! Otherwise we would have problems 
						in case of a retransmission of the FIN or a previous Packet */
					spTCB->u32RemoteReceived++;
					/*	Maybe we have a FIN as well in this Packet (TCP-Spec allows
						a direct change from FINWAIT1 to TIMEDWAIT without the
						intermidiate FINWAIT2 Step)
						Thus we continue execution with TCP_FINWAIT2!!!*/	
					/*	Our FIN is acknowledged. Stop the Timer!!! */
					EnterCritical();
					spTCB->s8TCPTxTimer		= 0;
					LeaveCritical();
			}else{
				/*	The Acknowledge is Invalid or doesn acknowledge all
					Data or it doesnt acknowledge our FIN. */
				break;
			}
		}else{
			/*	Not everything is send yet (maybe a retransmission has
				to be carried out). Wait until everything is send */
			break;
		}
/*----- TCP_FINWAIT2 --------------------------------------------------------*/
	case	TCP_FINWAIT2:
		/*	We send a FIN and got an ACK, now we wait for a FIN of the
			other site!!! Up to theire FIN we will continue to
			receive data */
		if((u8Flags & TCP_FIN) != 0){
			/*	We have a FIN. We need to Acknowledge the FIN. Thus we simply
				increment our Sequence number and we will automaticly acknowledge
				the FIN!!  */
				spTCB->u32LocalReceived++;
				/*	Lets acknowledge the FIN:
					We dont start the acknowledge-timer, because
					we already closed. Thus its not neccessary to
					wait for data we maybe want to transmitt!!! */
				tcp_queuetxtcb(spTCB);
				gu8NetworkSend	= 1;
			/*	Change State */
			spTCB->u8TCPState	= TCP_TIMEDWAIT;
			/*	Indicate that the Remote End has closed the Connection */
			spTCB->u8TCPFlags		|= 	TCPFLAG_RXEOF;
		}
		break;
/*----- TCP_LASTACK --------------------------------------------------------*/
	case	TCP_LASTACK:
	/*	The Remote-End send a FIN, we closed as well and send all
		our data, our last packet had a FIN as well and now we
		wait for the remote-end to acknowledge our FIN!!! */
		if((u8Flags & TCP_ACK) != 0){
			/* We have an ACK-Flag. Check if we have an Acknowledge of our FIN */
			if((TCP_TXBUFFERLENGTH - spTCB->u16TxBufferFree - spTCB->u16TxBufferOffset) == 0){
				/*	We may have stuff in the buffer, but it has been
					transmitted (thus no (re)transmission is going on */
				/*	Check if we have an Acknowledge of our FIN */
				if(u32AckNumber == (u32LastSend+1)){
					/*	We have a valid Acknowledge of our FIN-Flag (it has
						to be acknowledged like any other Data-octet).
						Later in this routine the Acknowledged data will be
						processed. There we will find out, that the currently
						processed Packet will Acknowledge all remaining Data,
						thus after this step we will have an empty buffer.
						This is important, we mustnt retransmitt after we
						accept that the remote end has acknowledged our FIN
						(Because we will increase the sequence-number!!!) */

						/*	We have an Acknowledge, thus the connection is closed!!
							We can go to the closed-state */
						//DANGER
						spTCB->u8TCPState		= TCP_CLOSED;
						/*	Our FIN is acknowledged. Thus we have to increment our
							sequence-number by one because a FIN counts like a data
							octet */
						/* DANGER: We can increase only after we received the remote
							acknowledge of our FIN!!! Otherwise we would have problems 
							in case of a retransmission of the FIN or a previous Packet */
						spTCB->u32RemoteReceived++;
						/*	Our FIN is acknowledged. Stop the Timer!!! */
						EnterCritical();
						spTCB->s8TCPTxTimer		= 0;
						LeaveCritical();
						/*	Signal both Events */
						SignalEvent(&spTCB->sTCPRxEvent);
						SignalEvent(&spTCB->sTCPTxEvent);
				}//END Right Ack-number check
			}//END All Data Transmitted-Check
		}//END ACK-Flag Check
			break;
/*----- TCP_CLOSEWAIT0 -------------------------------------------------------*/
		case	TCP_CLOSEWAIT0:
		/*	We received a FIN from the other site (we were in the
			TCP_CLOSEWAIT-State) and now our user wants us to
			close the connection as well. But first we have to
			transmitt all the data we have!!! */
/*----- LISTEN --------------------------------------------------------------*/
/*----- TCP_CLOSEWAIT -------------------------------------------------------*/
/*----- DEFAULT -------------------------------------------------------------*/
	default:
		break;
}
/*****************************************************************************/
/* Proccess the incomming Data: RST-Flag Check */
/*****************************************************************************/
/*	Maybe we got an RST-Flag set. Check this first */
if((u8Flags & TCP_RST) != 0){
	/*	The RST-Flag is set */
	/*	Close the connection */
	/*	Call the Handler and indicate an error	*/
	/*	Set Status to reset */
	spTCB->u8TCPState		= 	TCP_RESET;
	spTCB->u8TCPFlags		|= 	TCPFLAG_RESET;
	/*	Signal both Events */
	SignalEvent(&spTCB->sTCPRxEvent);
	SignalEvent(&spTCB->sTCPTxEvent);
	return;
}
/*****************************************************************************/
/* Proccess the incomming Data: PSH-Flag Check */
/*****************************************************************************/
/*	Maybe we got an RSH-Flag set. Check this first */
if((u8Flags & TCP_PSH) != 0){
	/* Inform a waiting task, that we have data */
	spTCB->u8TCPFlags		|= 	TCPFLAG_RXPSH;
	SignalEvent(&spTCB->sTCPRxEvent);
}
/*****************************************************************************/
/* Proccess the incomming Data: Window Check */
/*****************************************************************************/
/*	Read the current WindowSize of the remote-end */
u16TcpWindowSize		= tcp_windowsize(spTCPHeader);
/*	Check if the remote site has recovered from a zero window */
if((spTCB->u16RemoteWindowSize == 0) && (u16TcpWindowSize > 0)
		&& ((TCP_TXBUFFERLENGTH - spTCB->u16TxBufferFree) != 0)){
	/*	We have a Window-Update: The Remote side is ready to
		receive Data again!!! (And we have s.th. to send!!!) */
	tcp_queuetxtcb(spTCB);
	/*	The Buffer is full. Lets send the data */
	gu8NetworkSend	= 1;
	if(spTCB->u16TxBufferFree >= TCP_MINBUFFERFREE){
		/*	Stop a running retransmission-timer.
			DANGER: Its important that this is done before we
			proccess the data carried by the packet. Because if
			the packet carries data, this will trigger an acknowledge
			timeout */
		//TAKE Care of the TCP-State: Maybe we have an Fin Ack !!!!??
		EnterCritical();
		spTCB->s8TCPTxTimer		= 0;
		LeaveCritical();
		/*	We have enough space in the Transmit-Buffer, inform a waiting task */
		SignalEvent(&spTCB->sTCPTxEvent);
	}//END We have enough free space!!!
}
/*	Save the new Remote-Window size */
spTCB->u16RemoteWindowSize =	u16TcpWindowSize;
if((u16TcpWindowSize == 0) &&((TCP_TXBUFFERLENGTH - spTCB->u16TxBufferFree) != 0)){
	/*	The remote End is advertising a zero window, start a timer for
		Zero-Window Probes */
	EnterCritical();
	spTCB->s8TCPTxTimer	= TCP_ZEROWINDOWTIMEOUT;
	LeaveCritical();
}
/*****************************************************************************/
/* Proccess the incomming Data: Acknowledged Data */
/*****************************************************************************/
/*	We will work out if we have a valid ACK or not. In case of a 
	valid ACK we also retrive the amount of data the remote end
	acknowledged */
if((u8Flags & TCP_ACK) != 0){
/*	DANGER: The Variables have to be reloded because the 
	TCP-Finit-State Machine may have modified them!!
	(In case of SYN/FIN ...) */
	u32LastAck		= spTCB->u32RemoteReceived;
	u32LastSend		= u32LastAck + spTCB->u16TxBufferOffset;
	/*	The ACK-Flag is set */
	/*	The last acknowledged byte from the host is
		spTCB->ulRemoteReceived. */
	/*	Because the 32-bit sequence number will wrap around, we have
		to take care of this */
	if(u32LastSend >= u32LastAck){
		/*	We have the normal case: the Number we send is bigger (or equal)
			than the last Acknowledged number */
		if((u32AckNumber >= u32LastAck) && (u32AckNumber <= u32LastSend)){
			/*	We have a valid ACK-Number */
			u16AckDataCount	= (u16)(u32AckNumber - u32LastAck);
		}else{
			/*	We have an invalid ACK-Number */
			u16AckDataCount	= 0;
			u8ValidAck		= 0;
		}
	}else{
		/*	We have the annormal case: the Number we send is less
			than the last Acknowledged number. That means that everything
			up to the end (e.g. everything higher than the current
			ack-number) should be acknowledged and everything from zero
			up to the ulLastSend too */
		if(u32AckNumber >= u32LastAck){
			/*	We have a valid ACK-Number: Its between the last one and the 
				end of the number space */
			u16AckDataCount	= u32AckNumber - u32LastAck;
		}else if(u32AckNumber <= u32LastSend){
			/*	We have a valid ACK-Number: Its between the beginning of the
				address-space and the Number we transmitted the last time */
			/*	We acknoledge everything up to the end of the Space
				(0 - ulLastAck) and the stuff after the wrap */
			u16AckDataCount	=  (0 - u32LastAck) + u32AckNumber ;
		}else{
			/*	We have an invalid ACK-Number */
			u16AckDataCount	= 0;
			u8ValidAck		= 0;
		}
	}
	/*	If we have no acknowledged data we have to retransmit, if the remote end doesnt
		indicate that it cant receive data (by advertising a zero window).
		If this doesn`t acknowledges everything we send so far, that`s no problem, we
		have gained space as long as somthing was acknowledged and the transmit-mechanism
		will send new packages. A retransmit has to be done only if the remote end acknowledges
		nothing */
	if(u16AckDataCount == 0){
		/*	DANGER: If we send a FIN, the remote side will acknowledge one byte more
			than we actually send. This leads to a rejection of the Acknowledge, because
			the remote side acknowledges more data than we actually send. Thus we have to
			handle this case seperatly */
			if((u32AckNumber == u32LastAck) && (spTCB->u16TxBufferOffset != 0)){
/*************************** LOST FRAGMENT RETRANSMITT ***********************/
				/*	We have an acknowledge with the same number as the
					last time. We have to retransmitt */
				spTCB->u16TxBufferOffset	= 0;
				/*	Signal the NetworkTask: We have something to transmit */
				tcp_queuetxtcb(spTCB);
			}

		/*	If the number of acknowledged bytes is zero, we have to retransmit execpt
			the remote end indicates a zero window */
	}else{
		/*	We have a valid Acknowledgement:
			Reset the Retransmission-Counter */
				EnterCritical();
				spTCB->u8TCPRetransmissionCounter	= 0;
				LeaveCritical();
	
		/* The packet acknowledges data */
		u16Tmp	= spTCB->u8pTxBufferRead + u16AckDataCount - (spTCB->TxBuffer + TCP_TXBUFFERLENGTH);
		if((s16)u16Tmp < 0){
			/*	Even with Offset we havent reached the end of the Buffer */
			spTCB->u8pTxBufferRead 		+= u16AckDataCount;
		}else{
			/*	With the offset we reached the end of the Buffer. Wrap */
			spTCB->u8pTxBufferRead		= spTCB->TxBuffer + u16Tmp;
		}
		/*	We have to change the Remote-Sequence number */
			spTCB->u32RemoteReceived	+= u16AckDataCount;
		/*	We have to reduce the offset */
			spTCB->u16TxBufferOffset	-=	u16AckDataCount;
		/*	We have new free space */
			spTCB->u16TxBufferFree		+=	u16AckDataCount;

		if((spTCB->u16TxBufferFree == TCP_TXBUFFERLENGTH) && (spTCB->u8pTxBufferRead != spTCB->u8pTxBufferWrite)){
				while(1);
		}
		//DANGER!!!!!!
		if((spTCB->u16TxBufferFree >= TCP_MINBUFFERFREE) && (spTCB->u8TCPState == TCP_ESTABLISHED)){
			/*	Stop a running retransmission-timer if we are in the Established-State.
				DANGER: Its important that this is done before we
				proccess the data carried by the packet. Because if
				the packet carries data, this will trigger an acknowledge
				timeout 
				Remark: If we are not in the establish-state, we have to ensure that
				ACKs get send (maybe we have a FIN to Acknowledge) */
			EnterCritical();
			spTCB->s8TCPTxTimer		= 0;
			LeaveCritical();
			/*	We have enough space in the Transmit-Buffer, inform a waiting task */
			SignalEvent(&spTCB->sTCPTxEvent);
		}//END We have enough free space!!!
	}//END if Packet is carrying data
}
/*****************************************************************************/
/* Proccess the incomming Data: Read Data */
/*****************************************************************************/
//------	PROCESS RECEIVED DATA
	if(ethernet_dataleft() != 0){
		/*	The received frame was carrying data. */
		/*	Start the Acknowledge-Timer */
		EnterCritical();
		if(spTCB->s8TCPTxTimer == 0){
			spTCB->s8TCPTxTimer		= TCP_ACKNOWLEDGETIMEOUT;
		}
		LeaveCritical();
/*	REMARK: in the beginning we updated the number of bytes we still have in the
	frame (according to the TCP-Data remaining!. Thus the function
	"ethernet_readframe" returns the proper number of TCP-Data */
/*	We have to process the incomming data
	and write them to the Rx-Stream */
//------	CHECK SEQUENCE NUMBER
/* We expect that the incomming packet has the data we need next. We cant
   reassemble packets that got swaped */
	u8pRead			= spTCB->u8pRxBufferRead;
	u8pWrite		= spTCB->u8pRxBufferWrite;
	u8pStart		= spTCB->RxBuffer;
	u8pStop			= spTCB->RxBuffer+TCP_RXBUFFERLENGTH;
	u16Free			= spTCB->u16RxBufferFree;

	if(spTCB->u32LocalReceived == tcp_seqnumber(spTCPHeader)){
		/*	We have valid data. Thus we reset the
			Retransmission-Counter */
			EnterCritical();
			spTCB->u8TCPRetransmissionCounter	= 0;
			LeaveCritical();
	if(spTCB->u8TCPState	== TCP_ESTABLISHED){
		/*	If we are in the established-state and we received a FIN-Flag,
		 * 	we can change the state only if the packets data are valid. We
		 * 	have to increment our acknowledge counter by one to acknowledge
		 * 	the fin, but only if all other data are read in */
			if((u8Flags & TCP_FIN) != 0){
				/*	We have a FIN. We need to Acknowledge the FIN. Thus we simply
					increment our Sequence number and we will automaticly acknowledge
					the FIN!!  */
					spTCB->u32LocalReceived++;
					/*	Start the Acknowledge-Timer to acknowledge the FIN */
					EnterCritical();
					spTCB->s8TCPTxTimer		= TCP_ACKNOWLEDGETIMEOUT;
					LeaveCritical();
				/*	We wait for a close now: Send an ACK for the FIN!!! */
				spTCB->u8TCPState	= TCP_CLOSEWAIT;
				/*	Indicate that the Remote End has closed the Connection */
				spTCB->u8TCPFlags		|= 	TCPFLAG_RXEOF;
				/*	Alert the Event */
				SignalEvent(&spTCB->sTCPTxEvent);
			}
	}
			
		/*	Process the data */
		while(1){
			/*	Get amount of free space up to the buffer end */
			u16WriteLength	=	(u16)(u8pStop - u8pWrite);
			if(u16Free < u16WriteLength){
				/*	We have less space in the buffer. */
				u16WriteLength	=	(u16)(u8pRead - u8pWrite);
			}
			/*	Read the data into the buffer */
			u16Written	= 	ethernet_readframe(u8pWrite,u16WriteLength);
			spTCB->u32LocalReceived	+=	u16Written;
			u8pWrite				+=	u16Written;
			/*	We have less free space now */
			u16Free					-=	u16Written;
			/*	Check if we reached the end of the buffer */
			if(u8pWrite == u8pStop){
				u8pWrite	= u8pStart;
			}
			if((u16Written != u16WriteLength) || (u16Written == 0)){
				/*	We dont have to write again */
				break;
			}
		}
		/*	Write back the modified stuff */
		spTCB->u8pRxBufferWrite	= u8pWrite;
		spTCB->u16RxBufferFree	= u16Free;
		
//		tcp_queuetxtcb(spTCB);
		EnterCritical();
		spTCB->s8TCPTxTimer		= TCP_ACKNOWLEDGETIMEOUT;
		LeaveCritical();
		
		if((TCP_RXBUFFERLENGTH-u16Free) >= TCP_RXWAKEUP){
			/*	We have enough data in the buffer, wake up a
				waiting task */
				SignalEvent(&spTCB->sTCPRxEvent);
		}else{
			/*	We send at least an acknowledge back */

		}
	}else{
		/*	The sequence-number is not that what we expected, start an ack
		 * 	retransmission */
		u8pWrite--;
	}//END If: Good Sequence Number
	}else{//END If: Data left in the packet
		if(spTCB->u8TCPState	== TCP_ESTABLISHED){
			/*	If we are in the established-state and we received a FIN-Flag,
			 * 	we can change the state only if the packets data are valid. We
			 * 	have to increment our acknowledge counter by one to acknowledge
			 * 	the fin, but only if all other data are read in
			 * (now we can acknowledge, because the packet carries no data) */
				if((u8Flags & TCP_FIN) != 0){
					/*	We have a FIN. We need to Acknowledge the FIN. Thus we simply
						increment our Sequence number and we will automaticly acknowledge
						the FIN!!  */
						spTCB->u32LocalReceived++;
						/*	Start the Acknowledge-Timer to acknowledge the FIN */
						EnterCritical();
						spTCB->s8TCPTxTimer		= TCP_ACKNOWLEDGETIMEOUT;
						LeaveCritical();
					/*	We wait for a close now: Send an ACK for the FIN!!! */
					spTCB->u8TCPState	= TCP_CLOSEWAIT;
					/*	Indicate that the Remote End has closed the Connection */
					spTCB->u8TCPFlags		|= 	TCPFLAG_RXEOF;
					/*	Alert the Event */
					SignalEvent(&spTCB->sTCPTxEvent);
				}
		}
	}
/*****************************************************************************/
}
/*****************************************************************************/
