/*****************************************************************************/
/*	Copyright Sebastian Meuren 2003, 2008 
	
	This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>. */
/*****************************************************************************/
/* VS10xx */
/*****************************************************************************/
#ifndef	VS10xx__
#define	VS10xx__
#include "inttypes.h"
#include "spi.h"
#include "system.h"
/*****************************************************************************/
/*	VS10xx: Macros */
/*****************************************************************************/
//vs1053b Pinconfiguration
//XRESET -> PB.4
//XDCS -> PB.3
//XCS -> PB.2
//DREQ -> PD.2
/*	Reset-Line vs10xx: Low Output */
#define VS10xx_CONFIGURE_XRESET		DDRB 	|= _BV(4); 	PORTB 	&= ~_BV(4);
/*	XDCS-Line vs10xx: High Output */
#define VS10xx_CONFIGURE_XDCS		DDRB 	|= _BV(3); 	PORTB 	|= _BV(3);
/*	XCS-Line vs10xx: High Output */
#define VS10xx_CONFIGURE_XCS		DDRB 	|= _BV(2); 	PORTB 	|= _BV(2);
/*	DREQ: Input, nothing has to be done */
#define	VS10xx_CONFIGURE_DREQ	
/* Changing Pins */
#define	VS10xx_DREQ_STATUS		(PIND & _BV(2))
#define	VS10xx_SELECT_XRESET	PORTB |= _BV(4);
#define	VS10xx_DESELECT_XRESET	PORTB &= ~_BV(4);
#define	VS10xx_SELECT_XDCS		PORTB |= _BV(3);
#define	VS10xx_DESELECT_XDCS	PORTB &= ~_BV(3);
#define	VS10xx_SELECT_XCS		PORTB |= _BV(2);
#define	VS10xx_DESELECT_XCS		PORTB &= ~_BV(2);
/*****************************************************************************/
/* API */
/*****************************************************************************/
void	vs10xx_sinetest(u32 u32time);
u8		vs10xx_init(void);
void	vs10xx_reset(void);
void	vs10xx_cntr_wr(u8 u8Address,u16 u16Value);
u16		vs10xx_cntr_rd(u8 u8Address);
/*****************************************************************************/
/*	This is the inital volume of the vs10xx */
#define	VS10xx_INITVOLUME	0x00
/*****************************************************************************/
EVENT	gVS10xxDREQEvent;
#endif
